    .data
    # Dichiariamo una stringa in memoria globale, NULL-terminated
stringa:
    .asciiz "questa e' una stringa molto moolto lunga, x e' qui"
    
    .text
    .globl trovaX
trovaX:
    # Mettiamo la variabile "index" sullo stack
    # Riserviamo lo spazio necessario
    addi $sp, -4
    # Offset delle variabile "index" rispetto allo stack pointer
    .eqv INDEX, 0
    # Inizializziamo a zero la variabile "index"
    sw $zero, INDEX($sp)

    # Carichiamo l'indirizzo di "stringa"
    la $t1, stringa

loophead:   
    # Carichiamo l'indirizzo di "stringa"
    move $t2, $t1

    # Carichiamo la variabile "index"
    lw $t0, INDEX($sp)
    # Aggiungiamo il valore di "index"
    add $t2, $t2, $t0

    # Carichiamo dall'area di memoria risultante
    lb $t3, ($t2)

    # Carichiamo il valore costante 120 (valore decimale di 'x' in ASCII)
    li $t4, 120
    # Se il carattere caricato corrisponde a quello cercato, esci dal loop
    beq $t4, $t3, loopend

    # Aggiorniamo la variabile "index", leggendola, incrementandola e
    # riscrivendola
    lw $t0, INDEX($sp)
    addi $t0, 1
    sw $t0, INDEX($sp)

    # Fai un'altra iterazione del loop
    j loophead
loopend:

    # Carica il valore di "index"
    lw $t0, INDEX($sp)
    # Restituisci "index"
    move $v0, $t0

    # Ripristina lo stack
    addi $sp, 4
    j $ra
