    .text
    .globl dumb_adder
aggiungi42:
    # Riserviamo sullo stack lo spazio per due interi. Le variabili locali di
    # tipo array sono sempre sullo stack.
    addi $sp, -8
    # Offset rispetto a $sp dell'inizio dell'array
    .eqv BUFFER, -8

    # Dereferenziamo il puntatore passato come primo argomento
    lw $t1, ($a0)

    # Carichiamo l'indirizzo dell'inizio dell'array
    addi $t0, $sp, BUFFER
    # Salviamo come primo elemento il valore puntato dal primo argomento
    sw $t1, ($t0)

    # Carichiamo 42
    li $t1, 42
    # Salviamo come secondo elemento dell'array $t1 (42)
    sw $t1, 4($t0)

    # Carichiamo i due elementi dell'array
    lw $t2, ($t0)
    lw $t3, 4($t0)
    # Li sommiamo
    add $t3, $t3, $t2
    # Salviamo il risultato nell'area di memoria puntata dall'argomento "result"
    sw $t3, ($a0)

    # Ripristina lo stack
    addi $sp, 8

    jr $ra
    
    
dumb_adder:
    # Salveremo sullo stack $ra, $s0 e la variabile locale "result". Non usiamo
    # $fp.
    addiu $sp, -12
    # Offset dei valori sullo stack
    .eqv RA, -8
    .eqv S0, -4
    .eqv RES, 0
    # Salviamo $ra e $s0
    sw $ra, RA($sp)
    sw $s0, S0($sp)

    # Inizializziamo "result" con il valore del parametro "a"
    sw $a0, RES($sp)

    # Passiamo come primo parametro ad "aggiungi42" l'indirizzo di "result"
    addi $a0, $sp, RES
    jal aggiungi42

    # Restituiamo "result"
    lw $v0, RES($sp)

    # Ripristiniamo $ra e $s0
    lw $ra, RA($sp)
    lw $s0, S0($sp)

    # Ripristiniamo lo stack
    addi $sp, 12
    jr $ra
