# Organizzazione

Ogni esercizio è dotato di un file `support.c` che non va tradotta in assembly,
è solo un file di supporto per stampare in maniera semplice il risultato della
funzione che vogliamo implementare in assembly.

Oltre a questo file di supporto vi è il programma di riferimento scritto in C,
che va tradotto in assembly. La soluzione in assembly è il file `.S` con lo
stesso nome. Talvolta sono disponibili più varianti, denotati dal suffisso
`-2.S`, `-3.S` e così via.

# Compilare il programma

Per compilare la versione di riferimento in C:

    mips-linux-gnu-gcc support.c return42.c -o return42

Per compilare la versione in assembly:

    mips-linux-gnu-gcc support.c return42.S -o return42

Per eseguire il programma:

    qemu-mips ./return42

Rimpiazzare `return42` con il nome del file appropriato.