    .data
    # Dichiariamo una stringa in memoria globale, NULL-terminated
stringa:
    .asciiz "questa e' una stringa molto moolto lunga, x e' qui"

    .text
    .globl trovaX
trovaX:
    # La variabile "index" è assegnata a $t0, inizializziamola a zero
    li $t0, 0

    # Carichiamo l'indirizzo della variabile globale "stringa"
    la $t1, stringa

    # Inizio del loop
loophead:
    # Carichiamo l'indirizzo di "stringa"
    move $t2, $t1
    # Aggiungiamo il valore di "index"
    add $t2, $t2, $t0
    # Carichiamo dall'area di memoria risultante
    lb $t3, ($t2)

    # Carichiamo il valore costante 120 (valore decimale di 'x' in ASCII)
    li $t4, 120
    # Se il carattere caricato corrisponde a quello cercato, esci dal loop
    beq $t4, $t3, loopend

    # Incrementa "index"
    addi $t0, 1

    # Fai un'altra iterazione del loop
    j loophead
loopend:

    # Restituisci il valore di "index"
    move $v0, $t0
    j $ra
