    .data
    # Dichiariamo la variabile globale "risultato"
risultato:
    .word 1

    .text

    .globl fattoriale_dispari
moltiplica_condizionale:
    # Se il primo parametro è 0, esci dalla funzione immediatamente
    beq $zero, $a0, fine

    # Carica il suo valore
    lw $t1, risultato

    # Moltiplicalo per il secondo parametro
    mul $t2, $t1, $a1

    # Aggiorna il valore della variabile globale "risultato"
    sw $t2, risultato
fine:
    # Esci dalla funzione
    j $ra

fattoriale_dispari:
    # Abbassiamo lo stack, salveremo $ra e $a0
    addi $sp, -8
    # Offset rispetto allo stack pointer dei valori da salvarci
    .eqv RA, 0
    .eqv ARG1, 4

    # Salviamo l'indirizzo di ritorno (questa funzione chiama un'altra funzione)
    sw $ra, RA($sp)

loophead:
    # Controlla se l'argomento "a" è minore o uguale a zero
    blez $a0, loopend

    # Stiamo per fare una chiamata a funzione, dobbiamo salvare tutti i registri
    # caller-saved che ci servono, in questo caso, $a0
    sw $a0, ARG1($sp)

    # Imposta i due argomenti per la funzione "moltiplica_condizionale" ($a0 e
    # $a1)
    move $a1, $a0
    and $a0, $a0, 1
    # Effettua la chiamata a funzione (qui $ra viene modificato)
    jal moltiplica_condizionale
    # Ripristina $a0 dallo stack
    lw $a0, ARG1($sp)

    # Decerementa "a"
    addi $a0, -1

    # Fai un'altra iterazione
    j loophead

loopend:
    # Carica il valore della variabile globale "risultato" e restituiscilo
    lw $v0, risultato

    # Ripristina $ra
    lw $ra, RA($sp)
    # Ripristina lo stack
    addi $sp, 8

    # Torna al chiamante
    j $ra
