# Di cosa si tratta?

Questa cartella contiene un semplice programma di test per verificare che
l'ambiente di sviluppo per MIPS funzioni e sia possibile eseguire binari per
MIPS.

# Compilazione

    mips-linux-gnu-gcc hello.c -o hello

# Esecuzione

    ./hello

Oppure:

    qemu-mips ./hello

# Debugging

Attualmente il debugging funziona solo se si compila il programma staticamente.

    mips-linux-gnu-gcc -static hello.c -o hello
    qemu-mips -g 1234 ./hello

QEMU resterà in attesa, quindi, su un altro terminale:

    gdb-multiarch ./hello

Dare quindi in gdb i seguenti commandi:

    target remote :1234
    break main
    continue
    layout asm
    focus cmd

Usare `si` per eseguire un'istruzione o `ni` per continuare un'istruzione ma non
entrare nelle chiamate a funzione.

È anche possibile visualizzare il cambiamento dei registri ad ogni istruzione
attivando il layout registri:

    layout reg

Per uscire dal `layout asm` utilizzare `Ctrl + X, A`.
